<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/report_writer_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv3_p0 { color: #ff8bff; }
.textRainbow_lv2_p0 { color: #e0ffff; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>09/11/85  report_writer_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>Function:  The report_writer_ subroutine provides a programmer
<span id="L4" class="LineNr">  4 </span>interface to the MRW system.  Through it, application subsystems can
<span id="L5" class="LineNr">  5 </span>include generalized report writing capabilities, with a minimal amount
<span id="L6" class="LineNr">  6 </span>of coding required by the subsystem developer.
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>Entry points in report_writer_:
<span id="L10" class="LineNr"> 10 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>:Entry: convert_and_move_row: 09/11/85  report_writer_$convert_and_move_row
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>Function:  This entry converts a row of differing data types to a row
<span id="L16" class="LineNr"> 16 </span>of character string values and places it in the row value buffer.
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>Usage:
<span id="L20" class="LineNr"> 20 </span>dcl report_writer_$convert_and_move_row entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L21" class="LineNr"> 21 </span>call report_writer_$convert_and_move_row <span class="textRainbow_lv0_p0">(</span>report_writer_info_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L22" class="LineNr"> 22 </span>     value_ptrs<span class="textRainbow_lv0_p0">)</span>;
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>
<span id="L25" class="LineNr"> 25 </span>Arguments:
<span id="L26" class="LineNr"> 26 </span>report_writer_info_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L27" class="LineNr"> 27 </span>   is the pointer to the report_writer_ info structure returned by the
<span id="L28" class="LineNr"> 28 </span>   create_invocation entrypoint.
<span id="L29" class="LineNr"> 29 </span>value_ptrs <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L30" class="LineNr"> 30 </span>   is an array of pointers that point to the individual column values
<span id="L31" class="LineNr"> 31 </span>   that are to be converted.
<span id="L32" class="LineNr"> 32 </span>
<span id="L33" class="LineNr"> 33 </span>
<span id="L34" class="LineNr"> 34 </span>Notes:  The number of pointers in the array must be equivalent to the
<span id="L35" class="LineNr"> 35 </span>number of columns defined in the table.
<span id="L36" class="LineNr"> 36 </span>
<span id="L37" class="LineNr"> 37 </span>
<span id="L38" class="LineNr"> 38 </span>:Entry: create_invocation: 09/11/85  report_writer_$create_invocation
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>Function:  This entry creates a report_writer_ invocation.  It adds the
<span id="L41" class="LineNr"> 41 </span>standard report_writer_ request table and the standard requests info
<span id="L42" class="LineNr"> 42 </span>segments directory at location 99999 <span class="textRainbow_lv0_p0">(</span>see Notes<span class="textRainbow_lv0_p0">)</span>.
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>Usage:
<span id="L46" class="LineNr"> 46 </span>dcl report_writer_$create_invocation entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L47" class="LineNr"> 47 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> varying<span class="textRainbow_lv0_p0">)</span>;
<span id="L48" class="LineNr"> 48 </span>call report_writer_$create_invocation <span class="textRainbow_lv0_p0">(</span>table_manager_name<span class="textRainbow_lv0_o0">,</span>sci_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L49" class="LineNr"> 49 </span>     report_writer_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_o0">,</span> message<span class="textRainbow_lv0_p0">)</span>;
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>
<span id="L52" class="LineNr"> 52 </span>Arguments:
<span id="L53" class="LineNr"> 53 </span>table_manager_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L54" class="LineNr"> 54 </span>   is the name of the table manager procedure for the application
<span id="L55" class="LineNr"> 55 </span>   subsystem that is creating the report writer invocation.  If the
<span id="L56" class="LineNr"> 56 </span>   name is blank, report_writer_ obtains the name of the application
<span id="L57" class="LineNr"> 57 </span>   subsystem via the ssu_$get_subsystem_name subroutine and uses this
<span id="L58" class="LineNr"> 58 </span>   as the table manager procedure name.  Entry variables are
<span id="L59" class="LineNr"> 59 </span>   constructed by report_writer_ using the name of the table manager
<span id="L60" class="LineNr"> 60 </span>   procedure.
<span id="L61" class="LineNr"> 61 </span>sci_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L62" class="LineNr"> 62 </span>   is the ssu_ info pointer returned to the application subsystem when
<span id="L63" class="LineNr"> 63 </span>   the ssu_ invocation is created.  If this parameter is null, the
<span id="L64" class="LineNr"> 64 </span>   report_writer_ invocation is not created.
<span id="L65" class="LineNr"> 65 </span>
<span id="L66" class="LineNr"> 66 </span>
<span id="L67" class="LineNr"> 67 </span>report_writer_info_ptr <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L68" class="LineNr"> 68 </span>   is the pointer to the report_writer_ info structure.  This pointer
<span id="L69" class="LineNr"> 69 </span>   is passed as the first parameter to every other report_writer_
<span id="L70" class="LineNr"> 70 </span>   entry.
<span id="L71" class="LineNr"> 71 </span>code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L72" class="LineNr"> 72 </span>   is a standard error code.  If this is non-zero the invocation could
<span id="L73" class="LineNr"> 73 </span>   not be created.
<span id="L74" class="LineNr"> 74 </span>message <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L75" class="LineNr"> 75 </span>   if code is non-zero, this parameter contains the reason why the
<span id="L76" class="LineNr"> 76 </span>   invocation could not be created.  Declaring this argument as
<span id="L77" class="LineNr"> 77 </span>   &quot;character<span class="textRainbow_lv0_p0">(</span>128<span class="textRainbow_lv0_p0">)</span> varying&quot; provides an area large enough to contain
<span id="L78" class="LineNr"> 78 </span>   any returned error message.
<span id="L79" class="LineNr"> 79 </span>
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>Notes:  The table manager procedure is a program supplied by the
<span id="L82" class="LineNr"> 82 </span>application subsystem to manage data retrieval from its source data
<span id="L83" class="LineNr"> 83 </span>file.  The report_writer_ creates entry variables of the form
<span id="L84" class="LineNr"> 84 </span>&quot;table_manager_name$XX&quot;, where XX are the entries that must be
<span id="L85" class="LineNr"> 85 </span>available in the table manager procedure.  The required entries are
<span id="L86" class="LineNr"> 86 </span>create_table, delete_table, and get_row.  The optional entry is
<span id="L87" class="LineNr"> 87 </span>get_query.
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>The report_writer_ request tables provide a mechanism to include all of
<span id="L91" class="LineNr"> 91 </span>the report_writer_ standard requests <span class="textRainbow_lv0_p0">(</span>the default when an invocation is
<span id="L92" class="LineNr"> 92 </span>created<span class="textRainbow_lv0_p0">)</span>, or selected individual report_writer_ requests.  The request
<span id="L93" class="LineNr"> 93 </span>table &quot;report_writer_request_table_$standard_requests&quot; is used by the
<span id="L94" class="LineNr"> 94 </span>report_writer_$create_invocation entrypoint in a call to
<span id="L95" class="LineNr"> 95 </span>ssu_$add_request_table to add the report_writer_ standard requests to
<span id="L96" class="LineNr"> 96 </span>the subsystem's set of requests.  If the standard requests are not
<span id="L97" class="LineNr"> 97 </span>required, the subsystem should call ssu_$delete_request table with this
<span id="L98" class="LineNr"> 98 </span>as a parameter, after the call to report_writer_$create_invocation.
<span id="L99" class="LineNr"> 99 </span>The report_writer_ standard requests are:  column_value, display,
<span id="L100" class="LineNr">100 </span>display_builtins, list_format_options, restore_format_options,
<span id="L101" class="LineNr">101 </span>save_format_options, and set_format_options.  The other request tables
<span id="L102" class="LineNr">102 </span>defined to allow the addition of single requests are
<span id="L103" class="LineNr">103 </span>report_writer_request_table_$XXX_request, where XXX is the short name
<span id="L104" class="LineNr">104 </span>of the request.  These can be chosen from:  clv, di, dib, lsfo, rsfo,
<span id="L105" class="LineNr">105 </span>sfo, and svfo.
<span id="L106" class="LineNr">106 </span>
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span>The report_writer_info_dirs_ data segment provides a mechanism to
<span id="L109" class="LineNr">109 </span>include the directory containing the info segment for a request.  The
<span id="L110" class="LineNr">110 </span>report_writer_info_dirs_$standard_requests is used by the
<span id="L111" class="LineNr">111 </span>report_writer_$create_invocation entrypoint in a call to
<span id="L112" class="LineNr">112 </span>ssu_$add_info_dir, to add the info directory containing the info
<span id="L113" class="LineNr">113 </span>segments for the standard requests.  If the standard requests are not
<span id="L114" class="LineNr">114 </span>required, the subsystem should call ssu_$delete_info_dir with this as a
<span id="L115" class="LineNr">115 </span>parameter, after the call to report_writer_$create_invocation.  The
<span id="L116" class="LineNr">116 </span>other data items defined to allow the addition of directories which
<span id="L117" class="LineNr">117 </span>contain the info segment for a single request are
<span id="L118" class="LineNr">118 </span>report_writer_info_dirs_$XXX_requests, where XXX is the short name of
<span id="L119" class="LineNr">119 </span>the request.  These can be chosen from:  clv, di, dib, lsfo, rsfo, sfo,
<span id="L120" class="LineNr">120 </span>and svfo.
<span id="L121" class="LineNr">121 </span>
<span id="L122" class="LineNr">122 </span>
<span id="L123" class="LineNr">123 </span>:Entry: define_columns: 09/11/85  report_writer_$define_columns
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>Function:  This entry is used to inform report_writer_ that a set of
<span id="L126" class="LineNr">126 </span>columns have been selected.  All specific and general column options
<span id="L127" class="LineNr">127 </span>have new values assigned based on the newly selected columns.
<span id="L128" class="LineNr">128 </span>
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>Usage:
<span id="L131" class="LineNr">131 </span>dcl report_writer_$define_columns entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L132" class="LineNr">132 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_p0">)</span>);
<span id="L133" class="LineNr">133 </span>call report_writer_$define_columns <span class="textRainbow_lv0_p0">(</span>report_writer_info_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L134" class="LineNr">134 </span>     row_info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_o0">,</span> message<span class="textRainbow_lv0_p0">)</span>;
<span id="L135" class="LineNr">135 </span>
<span id="L136" class="LineNr">136 </span>
<span id="L137" class="LineNr">137 </span>Arguments:
<span id="L138" class="LineNr">138 </span>report_writer_info_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L139" class="LineNr">139 </span>   is the pointer to the report_writer_ info structure returned by the
<span id="L140" class="LineNr">140 </span>   create_invocation entrypoint.
<span id="L141" class="LineNr">141 </span>row_info_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L142" class="LineNr">142 </span>   is a pointer to the row_info structure described in the include file
<span id="L143" class="LineNr">143 </span>   rw_row_info.incl.pl1 <span class="textRainbow_lv0_p0">(</span>See &quot;Notes&quot; below.<span class="textRainbow_lv0_p0">)</span>  If this pointer is null,
<span id="L144" class="LineNr">144 </span>   any previously defined specific and general column option values are
<span id="L145" class="LineNr">145 </span>   deleted, and the only operations allowed are to general report
<span id="L146" class="LineNr">146 </span>   options until this entry is
<span id="L147" class="LineNr">147 </span>
<span id="L148" class="LineNr">148 </span>
<span id="L149" class="LineNr">149 </span>code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L150" class="LineNr">150 </span>   is a standard error code.  If this code is non-zero the values of
<span id="L151" class="LineNr">151 </span>   any previously defined specific and general columns options will
<span id="L152" class="LineNr">152 </span>   remain unchanged.
<span id="L153" class="LineNr">153 </span>message <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L154" class="LineNr">154 </span>   if code is non-zero this parameter will contain the reason for the
<span id="L155" class="LineNr">155 </span>   failure.  Declaring this argument as &quot;character<span class="textRainbow_lv0_p0">(</span>128<span class="textRainbow_lv0_p0">)</span> varying&quot;
<span id="L156" class="LineNr">156 </span>   provides an area large enough to contain any returned error message.
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>
<span id="L159" class="LineNr">159 </span>Notes:  The row_info structure declared in the include file
<span id="L160" class="LineNr">160 </span>rw_row_info.incl.pl1 is listed below, followed by a description of the
<span id="L161" class="LineNr">161 </span>members of this structure.
<span id="L162" class="LineNr">162 </span>
<span id="L163" class="LineNr">163 </span>   declare 1 row_info aligned based <span class="textRainbow_lv0_p0">(</span>row_info_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L164" class="LineNr">164 </span>           2 version char<span class="textRainbow_lv0_p0">(</span>8<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L165" class="LineNr">165 </span>           2 value_ptr ptr,
<span id="L166" class="LineNr">166 </span>           2 value_length fixed bin<span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L167" class="LineNr">167 </span>           2 number_of_columns fixed bin,
<span id="L168" class="LineNr">168 </span>           2 current_column_number fixed bin,
<span id="L169" class="LineNr">169 </span>           2 column <span class="textRainbow_lv0_p0">(</span>row_info_init_number_of_columns
<span id="L170" class="LineNr">170 </span>                     refer <span class="textRainbow_lv1_p0">(</span>row_info.number_of_columns<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>,
<span id="L171" class="LineNr">171 </span>             3 names char<span class="textRainbow_lv0_p0">(</span>128<span class="textRainbow_lv0_p0">)</span> varying,
<span id="L172" class="LineNr">172 </span>             3 descriptors bit<span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span>,
<span id="L173" class="LineNr">173 </span>             3 lengths fixed bin<span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L174" class="LineNr">174 </span>             3 indexes fixed bin<span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>;
<span id="L175" class="LineNr">175 </span>
<span id="L176" class="LineNr">176 </span>where:
<span id="L177" class="LineNr">177 </span>
<span id="L178" class="LineNr">178 </span>
<span id="L179" class="LineNr">179 </span>version
<span id="L180" class="LineNr">180 </span>   specifies to report_writer_ that the application subsystem is using
<span id="L181" class="LineNr">181 </span>   a particular version of the structure.  The only version currently
<span id="L182" class="LineNr">182 </span>   supported by report_writer_ is version 1.  The value of
<span id="L183" class="LineNr">183 </span>   ROW_INFO_VERSION_1, declared in the same include file, should be
<span id="L184" class="LineNr">184 </span>   assigned to row_info.version by the subsystem.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L185" class="LineNr">185 </span>value_ptr
<span id="L186" class="LineNr">186 </span>   is filled in by report_writer_ and points to the buffer where the
<span id="L187" class="LineNr">187 </span>   row value is placed by the application subsystem's table manager
<span id="L188" class="LineNr">188 </span>   procedure or the report_writer_$convert_and_move_row entrypoint.
<span id="L189" class="LineNr">189 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L190" class="LineNr">190 </span>value_length
<span id="L191" class="LineNr">191 </span>   is filled in by report_writer_ and is the length of the buffer for
<span id="L192" class="LineNr">192 </span>   the row value.  This is set to the exact number of characters needed
<span id="L193" class="LineNr">193 </span>   to contain the row value after conversion from internal data types
<span id="L194" class="LineNr">194 </span>   to the non-varying, unaligned character data types report_writer_
<span id="L195" class="LineNr">195 </span>   uses.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L196" class="LineNr">196 </span>
<span id="L197" class="LineNr">197 </span>
<span id="L198" class="LineNr">198 </span>number_of_columns
<span id="L199" class="LineNr">199 </span>   is filled in when the application subsystem allocates the row_info
<span id="L200" class="LineNr">200 </span>   structure, by setting the variable row_info_init_number_of_columns
<span id="L201" class="LineNr">201 </span>   to the number of columns that should be present in the table, before
<span id="L202" class="LineNr">202 </span>   the allocate statement is executed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L203" class="LineNr">203 </span>current_column_number
<span id="L204" class="LineNr">204 </span>   is set to zero by report_writer_ and can be used by the application
<span id="L205" class="LineNr">205 </span>   subsystem's table manager procedure to place individual column
<span id="L206" class="LineNr">206 </span>   values into the row value buffer.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L207" class="LineNr">207 </span>names
<span id="L208" class="LineNr">208 </span>   are filled in by the application subsystem, andare the names of the
<span id="L209" class="LineNr">209 </span>   individual columns.  These names must not contain whitespace because
<span id="L210" class="LineNr">210 </span>   of the request line syntax of the report_writer_ standard requests.
<span id="L211" class="LineNr">211 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L212" class="LineNr">212 </span>
<span id="L213" class="LineNr">213 </span>
<span id="L214" class="LineNr">214 </span>descriptors
<span id="L215" class="LineNr">215 </span>   are filled in by the application subsystem.  They are standard data
<span id="L216" class="LineNr">216 </span>   type descriptors for the column data as it appears in the source
<span id="L217" class="LineNr">217 </span>   file that the subsystem's table manager retrieves from.  In many
<span id="L218" class="LineNr">218 </span>   cases they describe columns that are not nonvarying, unaligned
<span id="L219" class="LineNr">219 </span>   character data types, and report_writer_ must convert the column
<span id="L220" class="LineNr">220 </span>   values to nonvarying character strings.  It uses these data
<span id="L221" class="LineNr">221 </span>   descriptors to do data conversion.  It also uses these descriptors
<span id="L222" class="LineNr">222 </span>   when generating default report column widths, column alignment
<span id="L223" class="LineNr">223 </span>   modes, etc.
<span id="L224" class="LineNr">224 </span>
<span id="L225" class="LineNr">225 </span>   If a descriptor is completely zero, the column is assumed by
<span id="L226" class="LineNr">226 </span>   report_writer_ to be a nonvarying, unaligned character string.  In
<span id="L227" class="LineNr">227 </span>   this case, the lengths field is used to determine the length in
<span id="L228" class="LineNr">228 </span>   characters of the column.  The descriptor is then set by
<span id="L229" class="LineNr">229 </span>   report_writer_ to a nonvarying, unaligned character descriptor and
<span id="L230" class="LineNr">230 </span>   its size portion is set to the value found in the lengths field.
<span id="L231" class="LineNr">231 </span>
<span id="L232" class="LineNr">232 </span>   Refer to the Programmer's Reference Manual, for a description of
<span id="L233" class="LineNr">233 </span>   Multics standard data type descriptors.  Refer to the include files
<span id="L234" class="LineNr">234 </span>   &quot;arg_descriptor.incl.pl1&quot; and &quot;std_descriptor_types.incl.pl1&quot; for
<span id="L235" class="LineNr">235 </span>   structures and named constants to set descriptors.  <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span>
<span id="L236" class="LineNr">236 </span>
<span id="L237" class="LineNr">237 </span>
<span id="L238" class="LineNr">238 </span>lengths
<span id="L239" class="LineNr">239 </span>   are filled in by report_writer_, and each is the number of
<span id="L240" class="LineNr">240 </span>   characters needed to contain the column value after conversion from
<span id="L241" class="LineNr">241 </span>   any supported data type to nonvarying, unaligned character format.
<span id="L242" class="LineNr">242 </span>   In the case where the descriptor is completely zero, lengths are set
<span id="L243" class="LineNr">243 </span>   by the caller.  The report_writer_ examines the value of this field
<span id="L244" class="LineNr">244 </span>   to determine the length in characters for the column.
<span id="L245" class="LineNr">245 </span>   <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span>
<span id="L246" class="LineNr">246 </span>
<span id="L247" class="LineNr">247 </span>
<span id="L248" class="LineNr">248 </span>indexes
<span id="L249" class="LineNr">249 </span>   are filled in by report_writer_, and each is the index into the row
<span id="L250" class="LineNr">250 </span>   value buffer for a particular column.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L251" class="LineNr">251 </span>
<span id="L252" class="LineNr">252 </span>   There are also three variables defined in this include file to
<span id="L253" class="LineNr">253 </span>   description of these variables follow.
<span id="L254" class="LineNr">254 </span>
<span id="L255" class="LineNr">255 </span>   row_value variable
<span id="L256" class="LineNr">256 </span>      provides a method to refer to the complete row value.  Its
<span id="L257" class="LineNr">257 </span>      declaration is:
<span id="L258" class="LineNr">258 </span>
<span id="L259" class="LineNr">259 </span>         declare row_value char<span class="textRainbow_lv0_p0">(</span>row_info.value_length<span class="textRainbow_lv0_p0">)</span>
<span id="L260" class="LineNr">260 </span>                 based <span class="textRainbow_lv0_p0">(</span>row_info.value_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L261" class="LineNr">261 </span>
<span id="L262" class="LineNr">262 </span>      A PL/I program to set the row value completely blank could use
<span id="L263" class="LineNr">263 </span>      the PL/I statement:
<span id="L264" class="LineNr">264 </span>
<span id="L265" class="LineNr">265 </span>         row_value = &quot; &quot;;
<span id="L266" class="LineNr">266 </span>
<span id="L267" class="LineNr">267 </span>   row_value_as_an_array variable
<span id="L268" class="LineNr">268 </span>      provides a method to refer to any single character within the row
<span id="L269" class="LineNr">269 </span>      value.  Its declaration is:
<span id="L270" class="LineNr">270 </span>
<span id="L271" class="LineNr">271 </span>         declare row_value_as_an_array <span class="textRainbow_lv0_p0">(</span>row_info.value_length<span class="textRainbow_lv0_p0">)</span>
<span id="L272" class="LineNr">272 </span>                 char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> based <span class="textRainbow_lv0_p0">(</span>row_info.value_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L273" class="LineNr">273 </span>
<span id="L274" class="LineNr">274 </span>      A PL/I program to set the 15th character within the row_value to
<span id="L275" class="LineNr">275 </span>      a blank could use the PL/I statement:
<span id="L276" class="LineNr">276 </span>
<span id="L277" class="LineNr">277 </span>         row_value_as_an_array <span class="textRainbow_lv0_p0">(</span>15<span class="textRainbow_lv0_p0">)</span> = &quot; &quot;;
<span id="L278" class="LineNr">278 </span>
<span id="L279" class="LineNr">279 </span>   column_value variable
<span id="L280" class="LineNr">280 </span>      provides a method to refer to a complete column value.  Its
<span id="L281" class="LineNr">281 </span>      declaration is:
<span id="L282" class="LineNr">282 </span>
<span id="L283" class="LineNr">283 </span>         declare column_value
<span id="L284" class="LineNr">284 </span>                 char  <span class="textRainbow_lv0_p0">(</span>row_info.column.lengths
<span id="L285" class="LineNr">285 </span>                         <span class="textRainbow_lv1_p0">(</span>row_info.current_column_number<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L286" class="LineNr">286 </span>                 based <span class="textRainbow_lv0_p0">(</span>addr <span class="textRainbow_lv1_p0">(</span>row_value_as_an_array
<span id="L287" class="LineNr">287 </span>                         <span class="textRainbow_lv2_p0">(</span>row_info.column.indexes
<span id="L288" class="LineNr">288 </span>                           <span class="textRainbow_lv3_p0">(</span>row_info.current_column_number<span class="textRainbow_lv3_p0">)</span><span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L289" class="LineNr">289 </span>
<span id="L290" class="LineNr">290 </span>      A PL/I program to set all of the columns to blanks could use the
<span id="L291" class="LineNr">291 </span>      PL/I code fragment:
<span id="L292" class="LineNr">292 </span>
<span id="L293" class="LineNr">293 </span>         do row_info.current_column_number =
<span id="L294" class="LineNr">294 </span>             1 to row_info.number_of_columns; column_value = &quot; &quot;;
<span id="L295" class="LineNr">295 </span>         end;
<span id="L296" class="LineNr">296 </span>
<span id="L297" class="LineNr">297 </span>
<span id="L298" class="LineNr">298 </span>:Entry: destroy_invocation: 09/11/85  report_writer_$destroy_invocation
<span id="L299" class="LineNr">299 </span>
<span id="L300" class="LineNr">300 </span>Function:  This entry destroys a report_writer_ invocation.
<span id="L301" class="LineNr">301 </span>
<span id="L302" class="LineNr">302 </span>
<span id="L303" class="LineNr">303 </span>Usage:
<span id="L304" class="LineNr">304 </span>dcl report_writer_$destroy_invocation entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L305" class="LineNr">305 </span>call report_writer_$destroy_invocation <span class="textRainbow_lv0_p0">(</span>report_writer_info_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L306" class="LineNr">306 </span>
<span id="L307" class="LineNr">307 </span>
<span id="L308" class="LineNr">308 </span>Arguments:
<span id="L309" class="LineNr">309 </span>report_writer_info_ptr <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span>
<span id="L310" class="LineNr">310 </span>   is the pointer to the report_writer_ info structure.  If this
<span id="L311" class="LineNr">311 </span>   pointer is null, the call is ignored.  This pointer is set to null
<span id="L312" class="LineNr">312 </span>   after the invocation is destroyed.
<span id="L313" class="LineNr">313 </span>
<span id="L314" class="LineNr">314 </span>
<span id="L315" class="LineNr">315 </span>:Entry: set_report_writer_info_ptr: 09/11/85  report_writer_$set_report_writer_info_ptr
<span id="L316" class="LineNr">316 </span>
<span id="L317" class="LineNr">317 </span>Function:  This entry is used by complex subsystems that require more
<span id="L318" class="LineNr">318 </span>than one report_writer_ invocation to be present in the subsystem
<span id="L319" class="LineNr">319 </span>invocation.  It takes the caller provided report_writer_ info pointer
<span id="L320" class="LineNr">320 </span>and places it in an internal location associated with the sci_ptr.
<span id="L321" class="LineNr">321 </span>When the next report_writer_ standard request is invoked, it uses the
<span id="L322" class="LineNr">322 </span>new report_writer_ info pointer now associated with its sci_ptr
<span id="L323" class="LineNr">323 </span>parameter.
<span id="L324" class="LineNr">324 </span>
<span id="L325" class="LineNr">325 </span>
<span id="L326" class="LineNr">326 </span>Usage:
<span id="L327" class="LineNr">327 </span>dcl report_writer_$set_report_writer_info_ptr entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L328" class="LineNr">328 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_p0">)</span>);
<span id="L329" class="LineNr">329 </span>call report_writer_$set_report_writer_info_ptr <span class="textRainbow_lv0_p0">(</span>report_writer_info_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L330" class="LineNr">330 </span>     sci_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_o0">,</span> message<span class="textRainbow_lv0_p0">)</span>;
<span id="L331" class="LineNr">331 </span>
<span id="L332" class="LineNr">332 </span>
<span id="L333" class="LineNr">333 </span>Arguments:
<span id="L334" class="LineNr">334 </span>report_writer_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L335" class="LineNr">335 </span>   is the pointer to a report_writer_ info structure.  This pointer
<span id="L336" class="LineNr">336 </span>   becomes the report_writer_ info pointer that is passed to the
<span id="L337" class="LineNr">337 </span>   report_writer_ standard requests.
<span id="L338" class="LineNr">338 </span>sci_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L339" class="LineNr">339 </span>   is the pointer to the ssu_ info structure returned to the subsystem
<span id="L340" class="LineNr">340 </span>   by the ssu_$create_invocation entrypoint.
<span id="L341" class="LineNr">341 </span>code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L342" class="LineNr">342 </span>   is a standard error code.  If this code is non-zero, the current
<span id="L343" class="LineNr">343 </span>   report_writer_ info pointer remains in effect.
<span id="L344" class="LineNr">344 </span>message <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L345" class="LineNr">345 </span>   if code is non-zero this parameter contains the reason for the
<span id="L346" class="LineNr">346 </span>   failure.  Declaring this argument as &quot;character <span class="textRainbow_lv0_p0">(</span>128<span class="textRainbow_lv0_p0">)</span> varying&quot;
<span id="L347" class="LineNr">347 </span>   provides an area large enough to contain any returned error message.
<span id="L348" class="LineNr">348 </span>
<span id="L349" class="LineNr">349 </span>
<span id="L350" class="LineNr">350 </span>Notes:  The most common type of subsystem using report_writer_ is one
<span id="L351" class="LineNr">351 </span>where there is only one report_writer_ invocation present in the one
<span id="L352" class="LineNr">352 </span>subsystem invocation.  If a subsystem requires more than one
<span id="L353" class="LineNr">353 </span>report_writer_ invocation to be present in the one subsystem
<span id="L354" class="LineNr">354 </span>invocation, call the report_writer_$create_invocation as many times as
<span id="L355" class="LineNr">355 </span>required, saving the returned report_writer_ info pointer after each
<span id="L356" class="LineNr">356 </span>call.  This entrypoint is then called with the desired report_writer_
<span id="L357" class="LineNr">357 </span>info pointer before any of the report_writer_ standard requests are
<span id="L358" class="LineNr">358 </span>used.  The call to this entrypoint ensures that the correct
<span id="L359" class="LineNr">359 </span>report_writer_ info pointer is used by the report_writer_ standard
<span id="L360" class="LineNr">360 </span>requests.
<span id="L361" class="LineNr">361 </span>
<span id="L362" class="LineNr">362 </span>
<span id="L363" class="LineNr">363 </span>:Entry: set_table_manager: 09/11/85  report_writer_$set_table_manager
<span id="L364" class="LineNr">364 </span>
<span id="L365" class="LineNr">365 </span>Function:  This entry is used by complex subsystems that require more
<span id="L366" class="LineNr">366 </span>than one table_manager procedure to be used in a report_writer_
<span id="L367" class="LineNr">367 </span>invocation.  It takes the caller provided table_manager name and
<span id="L368" class="LineNr">368 </span>creates entry variables to the expected entrypoints.  <span class="textRainbow_lv0_p0">(</span>See the
<span id="L369" class="LineNr">369 </span>&quot;report_writer_$create_invocation entrypoint&quot; for more information on
<span id="L370" class="LineNr">370 </span>the table_manager procedure.<span class="textRainbow_lv0_p0">)</span>  After this entrypoint is called, the
<span id="L371" class="LineNr">371 </span>next invocation of the report_writer_ display request uses this new
<span id="L372" class="LineNr">372 </span>table_manager procedure.
<span id="L373" class="LineNr">373 </span>
<span id="L374" class="LineNr">374 </span>
<span id="L375" class="LineNr">375 </span>Usage:
<span id="L376" class="LineNr">376 </span>dcl report_writer_$set_table_manager entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed
<span id="L377" class="LineNr">377 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_p0">)</span>;
<span id="L378" class="LineNr">378 </span>call report_writer_$set_table_manager <span class="textRainbow_lv0_p0">(</span>report_writer_info_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L379" class="LineNr">379 </span>     table_manager_name<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_o0">,</span> message<span class="textRainbow_lv0_p0">)</span>;
<span id="L380" class="LineNr">380 </span>
<span id="L381" class="LineNr">381 </span>
<span id="L382" class="LineNr">382 </span>Arguments:
<span id="L383" class="LineNr">383 </span>report_writer_info_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L384" class="LineNr">384 </span>   is the pointer to the report_writer_ info structure returned by the
<span id="L385" class="LineNr">385 </span>   report_writer_$create_invocation entrypoint.
<span id="L386" class="LineNr">386 </span>table_manager_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L387" class="LineNr">387 </span>   is the name of the new table_manager procedure.
<span id="L388" class="LineNr">388 </span>code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L389" class="LineNr">389 </span>   is a standard error code.  If this code is non-zero, the current
<span id="L390" class="LineNr">390 </span>   subsystem table_manager procedure remains in effect.
<span id="L391" class="LineNr">391 </span>message <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L392" class="LineNr">392 </span>   if code is non-zero, this parameter contains the reason for the
<span id="L393" class="LineNr">393 </span>   failure.  Declaring this argument as &quot;character <span class="textRainbow_lv0_p0">(</span>128<span class="textRainbow_lv0_p0">)</span> varying&quot;
<span id="L394" class="LineNr">394 </span>   provides an area large enough to contain any returned error message.
<span id="L395" class="LineNr">395 </span>
<span id="L396" class="LineNr">396 </span>
<span id="L397" class="LineNr">397 </span>Notes:  The most common type of subsystem using report_writer_ is one
<span id="L398" class="LineNr">398 </span>where there is only one table_manager procedure required for the one
<span id="L399" class="LineNr">399 </span>report_writer_ invocation.  If a subsystem wishes to switch between
<span id="L400" class="LineNr">400 </span>different table_manager procedures within one report_writer_
<span id="L401" class="LineNr">401 </span>invocation, this entrypoint should be called with the name of the new
<span id="L402" class="LineNr">402 </span>table_manager procedure.  The call to this entrypoint results in the
<span id="L403" class="LineNr">403 </span>new table_manager procedure being called the next time the
<span id="L404" class="LineNr">404 </span>report_writer_ display request is used.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
